"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.Color = void 0;
var eventhandler_1 = require("../render/eventhandler");
var Color = /** @class */ (function (_super) {
    __extends(Color, _super);
    function Color(r, g, b, a) {
        if (r === void 0) { r = 0; }
        if (g === void 0) { g = 0; }
        if (b === void 0) { b = 0; }
        if (a === void 0) { a = 1; }
        var _this = _super.call(this) || this;
        _this._r = 0.0;
        _this._g = 0.0;
        _this._b = 0.0;
        _this._a = 1.0;
        _this._r = r;
        _this._g = g;
        _this._b = b;
        _this._a = a;
        return _this;
    }
    Object.defineProperty(Color.prototype, "isColor", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Color.prototype, "r", {
        get: function () {
            return this._r;
        },
        set: function (value) {
            if (this._r !== value) {
                this._r = value;
                this.fire('change', 'r', this._r, value);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Color.prototype, "g", {
        get: function () {
            return this._g;
        },
        set: function (value) {
            if (this._g !== value) {
                this._g = value;
                this.fire('change', 'g', this._g, value);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Color.prototype, "b", {
        get: function () {
            return this._g;
        },
        set: function (value) {
            if (this._b !== value) {
                this._b = value;
                this.fire('change', 'b', this._b, value);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Color.prototype, "a", {
        get: function () {
            return this._a;
        },
        set: function (value) {
            if (this._a !== value) {
                this._a = value;
                this.fire('change', 'a', this._a, value);
            }
        },
        enumerable: false,
        configurable: true
    });
    Color.prototype.set = function (value) {
        if (value && value.isColor) {
            this.copy(value);
        }
        else if (typeof value === 'number') {
            this.setHex(value);
        }
        return this;
    };
    Color.prototype.setHex = function (hex) {
        hex = Math.floor(hex);
        if (hex > 0xffffff) {
            this._r = (hex >> 32 & 255) / 255;
            this._g = (hex >> 16 & 255) / 255;
            this._b = (hex >> 8 & 255) / 255;
            this._a = (hex & 255) / 255;
        }
        else {
            this._r = (hex >> 16 & 255) / 255;
            this._g = (hex >> 8 & 255) / 255;
            this._b = (hex & 255) / 255;
        }
        return this;
    };
    Color.prototype.setRGB = function (r, g, b, a) {
        if (a === void 0) { a = 1.0; }
        this._r = r;
        this._g = g;
        this._b = b;
        this._a = a;
        return this;
    };
    Color.prototype.clone = function () {
        return new this.constructor(this.r, this.g, this.b, this.a);
    };
    Color.prototype.copy = function (color) {
        this._r = color.r;
        this._g = color.g;
        this._b = color.b;
        return this;
    };
    Color.prototype.equals = function (c) {
        return (c.r === this.r) && (c.g === this.g) && (c.b === this.b);
    };
    Color.prototype.toArray = function (array, offset) {
        if (array === void 0) { array = []; }
        if (offset === void 0) { offset = 0; }
        array[offset] = this.r;
        array[offset + 1] = this.g;
        array[offset + 2] = this.b;
        array[offset + 3] = this.a;
        return array;
    };
    Color.prototype.getHex = function () {
        return (this.r * 255) << 32 ^ (this.g * 255) << 16 ^ (this.b * 255) << 8 ^ (this.a * 255) << 0;
    };
    Color.prototype.toJSON = function () {
        return this.getHex();
    };
    return Color;
}(eventhandler_1.EventHandler));
exports.Color = Color;
